#ifndef _RAM_H
#define _RAM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f4xx.h"
#include "bioloid_registers.h"

#define      RAM_SUCCESS       0
#define      RAM_BAD_ADDRESS  -1
#define      RAM_WRITE_ERROR  -2
#define      RAM_BAD_BIT      -3
#define      RAM_BAD_ACCESS   -4

#define      RAM_SIZE          256

extern uint8_t ram_data[RAM_SIZE];

void ram_init(void);
inline void ram_read_byte(uint8_t address, uint8_t *data);
inline void ram_read_word(uint8_t address, uint16_t *data);
uint8_t ram_read_table(uint8_t address, uint8_t length,uint8_t *data);
uint8_t ram_set_bit(uint8_t address, uint8_t bit);
uint8_t ram_clear_bit(uint8_t address, uint8_t bit);
uint8_t ram_write_byte(uint8_t address, uint8_t data);
uint8_t ram_write_word(uint8_t address, uint16_t data);
uint8_t ram_write_table(uint8_t address, uint8_t length,uint8_t *data);
inline uint8_t ram_in_range(uint8_t reg,uint8_t address,uint8_t length);
uint8_t ram_in_window(uint8_t start_reg,uint8_t reg_length,uint8_t start_address,uint8_t address_length);

#ifdef __cplusplus
}
#endif

#endif
